(function ($) {
  var dialog;
  var picker = null;
  var pickedAssets = [];
  assetPickerDialog ();
  Drupal.behaviors.celum_connect_widget = {
    attach: function (context) {
      $ ('#asset-picker-button').bind ('click', function (event) {
        event.preventDefault ();
        celumConnectFieldSetter ();
      });
      if($("#added_assets_table").find('tr').length == 0 && $('div:contains("No assets selected")').length > 0)  {
        $('.remove-assets-button').hide();
      }
      $('.remove-assets-button').bind ('click', function (event) {
        event.preventDefault ();
        $(".field-multiple-table tbody tr").remove();
        $ ('input[data-id="add_assets_celum_connect"]').mousedown ();
        removeAssets();
      });
    }
  };

  function contains(selector, text) {
    var elements = document.querySelectorAll(selector);
    return Array.from(elements).filter(function(element) {
      return RegExp(text).test(element.textContent);
    });
  }


  function assetPickerDialog () {
    let btns = {};
    btns[Drupal.t ('Cancel')] = function () {
      $ (this).dialog ("close");
    };
    let dialogHTML = '';
    dialogHTML += '<div id="celum_asset_picker_dialog">';
    let options = drupalSettings.download_asset + drupalSettings.direct_download_public_url_link + drupalSettings.anura_link + drupalSettings.anura_deep_link;
    if(options > 1) {
      dialogHTML += '<div id="picker-control"> ';
      if(drupalSettings.download_asset === 1) {
        dialogHTML += '<label class="radio-inline"> ' +
          '<input type="radio" checked name="optradio" value="download_asset">Download Asset ' +
          '</label> ';
      }
      if(drupalSettings.direct_download_public_url_link === 1) {
        dialogHTML += '<label class="radio-inline"> ' +
          '<input type="radio" checked name="optradio" value="direct_download_public_url_link">Direct Download / Public URL Link ' +
          '</label> ';
      }
      if(drupalSettings.anura_link === 1) {
        dialogHTML += '<label class="radio-inline"> ' +
          '<input type="radio" checked name="optradio" value="anura_link">Anura Link ' +
          '</label> ';
      }
      if(drupalSettings.anura_deep_link === 1) {
        dialogHTML += '<label class="radio-inline"> ' +
          '<input type="radio" checked name="optradio" value="anura_deep_link">Anura Deep Link ' +
          '</label> ';
      }
      dialogHTML += '</div>';
    }
    dialogHTML += '<div id="picker-wrap"></div>';
    dialogHTML += '</div>';


    $ ('body').append (dialogHTML);

    dialog = $ ('#celum_asset_picker_dialog').dialog ({
      modal: true,
      autoOpen: false,
      width: 1320,
      height: 800,
      closeOnEscape: true,
      resizable: false,
      draggable: false,
      dialogClass: 'celum_asset_picker_dialog',
      buttons: btns
    });
  }

  function celumConnectFieldSetter () {
    dialog.dialog ('open');
    if (picker === null) {
      createAssetPicker (dialog);
    }
    return false;
  }

  function createAssetPicker (dialog) {
    let configIndex = null;
    if(drupalSettings.urlRootNodeMap) {
      let urlRootNodeArray = drupalSettings.urlRootNodeMap.split(";");
      let i = 0;
      urlRootNodeArray.forEach( function (urlRootNodeString) {
        let urlRootNodePair = urlRootNodeString.split(">");
        if(window.location.origin === urlRootNodePair[0]) {
          configIndex = i;
          return;
        }
        i++
      })
    }
    let configPath;
    if(configIndex != null) {
      configPath = window.location.origin + drupalSettings.path.baseUrl + 'sites/default/files/celum_connect/config_'+configIndex+'.js?'+(new Date()).getTime();
    }else {
      configPath = window.location.origin + drupalSettings.path.baseUrl + 'sites/default/files/celum_connect/config.js?'+(new Date()).getTime();
    }
    picker = Celum.AssetPicker.create ({
      container: 'picker-wrap',
      basePath:  window.location.origin + drupalSettings.path.baseUrl + drupalSettings.module_path + "/",
      jsConfigPath: configPath,
      listeners: {
        transfer: function (id, selections) {
          var assets = [];
          selections.forEach (function (asset) {
            var selectedDownloads = asset.selectedDownloads;
            selectedDownloads.forEach (function (selectedDownload) {
              assets.push (
                {
                  url: asset['@odata.mediaReadLink'],
                  id: asset['id'],
                  version: asset['versionInformation']['versionId'],
                  downloadFormat: selectedDownload,
                  fileExtension: asset['fileInformation']['fileExtension'],
                  title: asset['name'],
                  fileCategory: asset['fileCategory'],
                  preview: asset['previewInformation']['previewUrl'],
                  thumb: asset['previewInformation']['thumbUrl']
                });
            });
          });
          addAssets (assets, jQuery("input[name='optradio']:checked").val());
          assets = [];
          dialog.dialog ("close");
        }
      }
    });
  }

  function removeAssets () {
    $("#added_assets_table").empty();
    $ ('input[name="assetsNum"]').prop ('value', 0).attr ('value', 0);
    let i = 0;
    $ ('#added_assets_table').append (
      '<tr> ' +
      '<td>' +
      '<input data-id-delta="' + i + '" type="hidden" name="added_asset[' + i + '][id]" value=""> ' +
      '<input data-downloadformat-delta="' + i + '"type="hidden" name="added_asset[' + i + '][downloadFormat]" value=""> ' +
      '<input data-version-delta="' + i + '" type="hidden" name="added_asset[' + i + '][version]" value=""> ' +
      '<input data-fileextension-delta="' + i + '" type="hidden" name="added_asset[' + i + '][fileExtension]" value=""> ' +
      '<input data-filecategory-delta="' + i + '" type="hidden" name="added_asset[' + i + '][fileCategory]" value=""> ' +
      '<input data-title-delta="' + i + '" type="hidden" name="added_asset[' + i + '][title]" value=""> ' +
      '<input data-thumb-delta="' + i + '" type="hidden" name="added_asset[' + i + '][thumb]" value=""> ' +
      '<input data-uri-delta="' + i + '" type="hidden" name="added_asset[' + i + '][uri]" value=""> ' +
      '<input data-type-delta="' + i + '" type="hidden" name="added_asset[' + i + '][type]" value=""> ' +
      '</td> ' +
      '<td > ' +
      '</td> ' +
      '</tr>');
    $ ('input[data-id-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-downloadFormat-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-version-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-fileExtension-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-fileCategory-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-title-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-thumb-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-uri-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-type-delta="' + i + '"]').prop ('value', "").attr ('value', "");
    $ ('input[data-id="add_assets_celum_connect"]').mousedown ();

  }


  function addAssets (assets, type) {
    $ ('input[name="assetsNum"]').prop ('value', assets.length).attr ('value', assets.length);
    pickedAssets = assets;
    for (var i = 0; i < assets.length; i++) {
      $ ('#added_assets_table').append (
        '<tr> ' +
        '<td>' +
        '<input data-id-delta="' + i + '" type="hidden" name="added_asset[' + i + '][id]" value=""> ' +
        '<input data-downloadformat-delta="' + i + '"type="hidden" name="added_asset[' + i + '][downloadFormat]" value=""> ' +
        '<input data-version-delta="' + i + '" type="hidden" name="added_asset[' + i + '][version]" value=""> ' +
        '<input data-fileextension-delta="' + i + '" type="hidden" name="added_asset[' + i + '][fileExtension]" value=""> ' +
        '<input data-filecategory-delta="' + i + '" type="hidden" name="added_asset[' + i + '][fileCategory]" value=""> ' +
        '<input data-title-delta="' + i + '" type="hidden" name="added_asset[' + i + '][title]" value=""> ' +
        '<input data-thumb-delta="' + i + '" type="hidden" name="added_asset[' + i + '][thumb]" value=""> ' +
        '<input data-uri-delta="' + i + '" type="hidden" name="added_asset[' + i + '][uri]" value=""> ' +
        '<input data-type-delta="' + i + '" type="hidden" name="added_asset[' + i + '][type]" value=""> ' +
        '</td> ' +
        '<td > ' +
        '</td> ' +
        '</tr>');
      $ ('input[data-id-delta="' + i + '"]').prop ('value', pickedAssets[i].id).attr ('value', pickedAssets[i].id);
      $ ('input[data-downloadFormat-delta="' + i + '"]').prop ('value', pickedAssets[i].downloadFormat).attr ('value', pickedAssets[i].downloadFormat);
      $ ('input[data-version-delta="' + i + '"]').prop ('value', pickedAssets[i].version).attr ('value', pickedAssets[i].version);
      $ ('input[data-fileExtension-delta="' + i + '"]').prop ('value', pickedAssets[i].fileExtension).attr ('value', pickedAssets[i].fileExtension);
      $ ('input[data-fileCategory-delta="' + i + '"]').prop ('value', pickedAssets[i].fileCategory).attr ('value', pickedAssets[i].fileCategory);
      $ ('input[data-title-delta="' + i + '"]').prop ('value', pickedAssets[i].title).attr ('value', pickedAssets[i].title);
      $ ('input[data-thumb-delta="' + i + '"]').prop ('value', pickedAssets[i].thumb).attr ('value', pickedAssets[i].thumb);
      $ ('input[data-uri-delta="' + i + '"]').prop ('value', pickedAssets[i].uri).attr ('value', pickedAssets[i].uri);
      $ ('input[data-type-delta="' + i + '"]').prop ('value', pickedAssets[i].type).attr ('value', type);
    }
    $ ('input[data-id="add_assets_celum_connect"]').mousedown ();

  }

}) (jQuery);
